Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| " 2013 FRC Java API "
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.sun.squawk.util
Class SquawkHashtable

    java.lang.Object
      com.sun.squawk.util.SquawkHashtable

    public class SquawkHashtable

extends Object

This class implements a variation of `Hashtable` that is unsynchronized. Any non-`null` object can be used as a key or as a value.

To successfully store and retrieve objects from a hashtable, the objects used as keys must implement the `hashCode` method and the `equals` method.

An instance of `SquawkHashtable` has two parameters that affect its efficiency: its capacity and its load factor. The load factor is always 0.75. When the number of entries in the hashtable exceeds the product of the load factor and the current capacity, the capacity is increased by calling the `rehash` method. Larger load factors use memory more efficiently, at the expense of larger expected time per lookup.

If many entries are to be made into a `SquawkHashtable`, creating it with a sufficiently large capacity may allow the entries to be inserted more efficiently than letting it perform automatic rehashing as needed to grow the table.

This example creates a hashtable of numbers. It uses the names of the numbers as keys:

>          SquawkHashtable numbers = new SquawkHashtable();
>          numbers.put("one", new Integer(1));
>          numbers.put("two", new Integer(2));
>          numbers.put("three", new Integer(3));

To retrieve a number, use the following code:

>          Integer n = (Integer)numbers.get("two");
>          if (n != null) {
>              System.out.println("two = " + n);
>          }

Note: To conserve space, the CLDC implementation is based on JDK 1.1.8, not JDK 1.3.

Since:
  JDK1.0, CLDC 1.0
Version:
  1.42, 07/01/98 (CLDC 1.0, Spring 2000)
See Also:
  `Object.equals(java.lang.Object)`, `Object.hashCode()`, `Hashtable`, `rehash()`

Nested Class Summary
`static interface` | `SquawkHashtable.Rehasher`

Constructor Summary
`SquawkHashtable()` Constructs a new, empty hashtable with a default capacity and load factor.
`SquawkHashtable(int initialCapacity)` Constructs a new, empty hashtable with the specified initial capacity.

Method Summary
`int` | `capacity()` Return the current capacity of the hashtable.
`void` | `clear()` Clears this hashtable so that it contains no keys.
`boolean` | `contains(Object value)` Tests if some key maps into the specified value in this hashtable.
`boolean` | `containsKey(Object key)` Tests if the specified object is a key in this hashtable.
`Enumeration` | `elements()` Returns an enumeration of the values in this hashtable.
`static String` | `enumerationsToString(Enumeration keys, Enumeration elements, int size)` Utility class to get a rather long string representation of any kind of hashtable.
`Object` | `get(Object key)` Returns the value to which the specified key is mapped in this hashtable.
`com.sun.squawk.util.HashtableEntry[]` | `getEntryTable()` Return the internal table.
`boolean` | `isEmpty()` Tests if this hashtable maps no keys to values.
`Enumeration` | `keys()` Returns an enumeration of the keys in this hashtable.
`Object` | `put(Object key, Object value)` Maps the specified `key` to the specified `value` in this hashtable.
`void` | `rehash()` Rehashes the contents of the hashtable into a hashtable with a larger capacity.
`Object` | `remove(Object key)` Removes the key (and its corresponding value) from this hashtable.
`SquawkHashtable` | `setRehasher(SquawkHashtable.Rehasher rehasher)`
`int` | `size()` Returns the number of keys in this hashtable.
`String` | `toString()` Returns a rather long string representation of this hashtable.

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### SquawkHashtable

    public SquawkHashtable(int initialCapacity)

  Constructs a new, empty hashtable with the specified initial capacity.

  Parameters:
    `initialCapacity` - the initial capacity of the hashtable.
  Throws:
    `IllegalArgumentException` - if the initial capacity is less than zero
  Since:
    JDK1.0

### SquawkHashtable

    public SquawkHashtable()

  Constructs a new, empty hashtable with a default capacity and load factor.

  Since:
    JDK1.0

Method Detail

### setRehasher

    public final SquawkHashtable setRehasher(SquawkHashtable.Rehasher rehasher)

### size

    public final int size()

  Returns the number of keys in this hashtable.

  Returns:
    the number of keys in this hashtable.
  Since:
    JDK1.0

### isEmpty

    public final boolean isEmpty()

  Tests if this hashtable maps no keys to values.

  Returns:
    `true` if this hashtable maps no keys to values; `false` otherwise.
  Since:
    JDK1.0

### keys

    public Enumeration keys()

  Returns an enumeration of the keys in this hashtable.

  Returns:
    an enumeration of the keys in this hashtable.
  See Also:
    `Enumeration`, `JDK1.0`

### elements

    public Enumeration elements()

  Returns an enumeration of the values in this hashtable. Use the Enumeration methods on the returned object to fetch the elements sequentially.

  Returns:
    an enumeration of the values in this hashtable.
  See Also:
    `Enumeration`, `JDK1.0`

### contains

    public boolean contains(Object value)

  Tests if some key maps into the specified value in this hashtable. This operation is more expensive than the `containsKey` method.

  Parameters:
    `value` - a value to search for.
  Returns:
    `true` if some key maps to the `value` argument in this hashtable; `false` otherwise.
  Throws:
    `NullPointerException` - if the value is `null`.
  Since:
    JDK1.0
  See Also:
    `java.util.Hashtable#containsKeySquawkHashtableg.Object)`

### containsKey

    public boolean containsKey(Object key)

  Tests if the specified object is a key in this hashtable.

  Parameters:
    `key` - possible key.
  Returns:
    `true` if the specified object is a key in this hashtable; `false` otherwise.
  Since:
    JDK1.0
  See Also:
    `java.util.Hashtable#SquawkHashtablejava.lang.Object)`

### get

    public Object get(Object key)

  Returns the value to which the specified key is mapped in this hashtable.

  Parameters:
    `key` - a key in the hashtable.
  Returns:
    the value to which the key is mapped in this hashtable; `null` if the key is not mapped to any value in this hashtable.
  Since:
    JDK1.0
  See Also:
    `java.util.Hashtable#SquawkHashtablelang.Object, java.lang.Object)`

### rehash

    public void rehash()

  Rehashes the contents of the hashtable into a hashtable with a larger capacity. This method is called automatically when the number of keys in the hashtable exceeds this hashtable's capacity and load factor. This is not a public method, made it public to enable the java.util.SquawkHashtable.rehash to delegate to this one.

  Since:
    JDK1.0

### put

    public Object put(Object key,
                      Object value)

  Maps the specified `key` to the specified `value` in this hashtable. Neither the key nor the value can be `null`.

  The value can be retrieved by calling the `get` method with a key that is equal to the original key.

  Parameters:
    `key` - the hashtable key.
    `value` - the value.
  Returns:
    the previous value of the specified key in this hashtable, or `null` if it did not have one.
  Throws:
    `NullPointerException` - if the key or value is `null`.
  See Also:
    `Object.equals(java.lang.Object)`, `java.util.Hashtable#get(java.lang.ObjecSquawkHashtable JDK1.0`

### remove

    public Object remove(Object key)

  Removes the key (and its corresponding value) from this hashtable. This method does nothing if the key is not in the hashtable.

  Parameters:
    `key` - the key that needs to be removed.
  Returns:
    the value to which the key had been mapped in this hashtable, or `null` if the key did not have a mapping.
  Since:
    JDK1.0

### clear

    public void clear()

  Clears this hashtable so that it contains no keys.

  Since:
    JDK1.0

### toString

    public String toString()

  Returns a rather long string representation of this hashtable.

  Overrides:
    `toString` in class `Object`
  Returns:
    a string representation of this hashtable.
  Since:
    JDK1.0

### capacity

    public final int capacity()

  Return the current capacity of the hashtable.

  Returns:
    the current capacity

### getEntryTable

    public final com.sun.squawk.util.HashtableEntry[] getEntryTable()

  Return the internal table. Used by GC for bookkeeping. THIS IS PRIVATE TO THE BOOTSTRAP SUITE

  Returns:
    the internal table

### enumerationsToString

    public static String enumerationsToString(Enumeration keys,
                                              Enumeration elements,
                                              int size)

  Utility class to get a rather long string representation of any kind of hashtable.

  Parameters:
    `keys` -
    `elements` -
    `size` -
  Returns:
    a string representation of this hashtable.
  Since:
    JDK1.0

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| " 2013 FRC Java API "
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

"
For updated information see the Java FRC site
"